
import matplotlib.pyplot as plt
from matplotlib.pyplot import figure
import numpy as np
from sklearn.metrics import accuracy_score, mean_squared_error,roc_auc_score,precision_score, roc_curve, roc_auc_score, mean_absolute_percentage_error, mean_absolute_error
from sklearn.metrics import roc_auc_score
from sklearn.metrics import roc_curve
from sklearn.metrics import recall_score
from sklearn.metrics import precision_score
    
def model_evaluator(model, X_test, y_test, classification=True, threshold=.5):

    y_pred = model.predict(X_test)

    if classification:
        y_pred_threshold = np.array([0 if _ <=threshold else 1 for _ in y_pred])       
        
        print('Null Accuracy Score: ', accuracy_score(y_test[y_test==0], y_pred_threshold[y_test==0]))
        print('AUC Score: ', roc_auc_score(y_test, y_pred))
        
        print('Recall Score: ', recall_score(y_test, y_pred_threshold))
        print('Precision Score: ', precision_score(y_test, y_pred_threshold))
        
    else:
        print('Mape: ', mean_absolute_percentage_error(y_test, y_pred))
    
    print('Test MAE: ', mean_absolute_error(y_test, y_pred))
                                   
                                   
                                   
    non_zero_test = y_test
    non_zero_pred = y_pred

    arr1inds = np.flip(non_zero_test.argsort())
    sorted_arr1 = non_zero_test[arr1inds[::-1]]
    sorted_arr2 = non_zero_pred[arr1inds[::-1]]
    
    if classification:
        sorted_arr3 = y_pred_threshold[arr1inds[::-1]]

    figure(figsize=(20, 6), dpi=80)


    start = 800
    size_1 = start
    size_2 = start+100

    # plotting the line 1 points 
    plt.scatter(range(len(sorted_arr1)), sorted_arr2, label = "Pred", c='red')
    # line 2 points

    plt.scatter(range(len(sorted_arr1)), sorted_arr1, label = "True", c='green', alpha=0.5)

    #if classification:
        #plt.scatter(range(len(sorted_arr3)), sorted_arr3, label = "Pred Threshold", c='blue', alpha=0.1)

        
    plt.xlabel('Ordered')
    # Set the y axis label of the current axis.
    plt.ylabel('Values')
    # Set a title of the current axes.
    plt.title('Test Predictions')
    # show a legend on the plot
    plt.legend()
    #plt.ylim(-0.01,np.max(y_test)+.01)
    # Display a figure.
    plt.show()
    
